
/*	Copyright (C) G. Jespersen
	See Licence.txt.*/

#if !defined TEXTSEL_H
#define TEXTSEL_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Stdafx.h"

// 10/04/2017
//////////////////////////////////////////////////////////////
// CStrHglt - a single string to highlight
class CStrHglt
{
public:
	CStrHglt();
	~CStrHglt();
	CStrHglt(const CStrHglt & strHglt);
	void	operator=(const CStrHglt & strHglt);
	BOOL	operator==(const CStrHglt & strHglt);
	BOOL	operator!=(const CStrHglt & strHglt);
	void	Copy(const CStrHglt & strHglt);
	void	Zero();
	CString m_str;
	CRect	m_rect;
	int		m_iStartChar;
	int		m_iEndChar;
	int		m_srcArElmt;
	BOOL	m_isEmptyLine;
};


//////////////////////////////////////////////////////////////
// CTextSel
class CTextSel
{
public:
	CTextSel();
	~CTextSel();
	CTextSel(const CTextSel & textSel);
	void	operator=(const CTextSel & textSel);
	BOOL	operator==(const CTextSel & textSel);
	BOOL	operator!=(const CTextSel & textSel);
	void	Copy(const CTextSel & textSel);
	void	Zero();

	BOOL	IsValid(const CStringArray & srcStrAr);
	BOOL	SetHightlightStrings(const CStringArray & srcStrAr, CClientDC & dc,
								 CSize textOffset, CRect & clipRect);
	void	DrawHighlight(CDC * pDC, LOGFONT lf);
	CRect	GetClipRect();
	void	SetStartDragPt(CPoint start, CRect & clip);
	BOOL	SetEndDragPt(CPoint end, const CStringArray & srcStrAr,
						 CClientDC & dc, CSize textOffset, CRect & clip);
	BOOL	ValidEndPt(CPoint end);
	BOOL	GetSelectedText(CString & str);
	BOOL	PointInSelection(const CPoint & pt);

	// Helpers
	void	PointZero(CPoint & p){ p.x = 0; p.y = 0; };
	BOOL	PointIsEmpty(CPoint & p){ return (p.x <= 0 && p.y <= 0); };

	CPoint	m_dragStartPt;
	CPoint	m_dragEndPt;
	CArray<CStrHglt, CStrHglt&> m_strHgltAr;
};


#endif // TEXTSEL_H